/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.005        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: m_invert.c
 * Program name: library modules only
 * Source of file: The Public Domain Software Library.
 * Purpose: Matrix maths function
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/

static char *sccsid = "@(#)m_invert.c	4/7/82 (U of Maryland, FLB)";

#include "mat.h"

struct matrix *
m_invert(mat)
register struct matrix *mat;
{
register struct matrix *result;
register int row, col;
double det;

if((det = m_determinant(mat)) == 0.0) {
	printf("m_invert: singular matrix\n");
	return(M_NULL);
	}

m_create(result, mat->m_cols, mat->m_rows);

for (row = 0; row < mat->m_rows; row++)
	for (col = 0; col < mat->m_cols; col++)
		m_v(result, col, row) = m_cofactor(mat, row, col) / det;

return(result);
}
